diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-mac-queue.cc ns-3.34/src/wifi/model/wifi-mac-queue.cc
--- ns-3.33/src/wifi/model/wifi-mac-queue.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-mac-queue.cc	2021-07-14 10:31:07.000000000 -0700
@@ -24,6 +24,7 @@
 #include "ns3/simulator.h"
 #include "wifi-mac-queue.h"
 #include "qos-blocked-destinations.h"
+#include <functional>
 
 namespace ns3 {
 
@@ -70,9 +71,11 @@
 WifiMacQueue::~WifiMacQueue ()
 {
   NS_LOG_FUNCTION_NOARGS ();
+  m_nQueuedPackets.clear ();
+  m_nQueuedBytes.clear ();
 }
 
-static std::list<Ptr<WifiMacQueueItem>> g_emptyWifiMacQueue;
+static std::list<Ptr<WifiMacQueueItem>> g_emptyWifiMacQueue; //!< empty Wi-Fi MAC queue
 
 const WifiMacQueue::ConstIterator WifiMacQueue::EMPTY = g_emptyWifiMacQueue.end ();
 
@@ -92,8 +95,6 @@
 bool
 WifiMacQueue::TtlExceeded (ConstIterator &it)
 {
-  NS_LOG_FUNCTION (this);
-
   if (Simulator::Now () > (*it)->GetTimeStamp () + m_maxDelay)
     {
       NS_LOG_DEBUG ("Removing packet that stayed in the queue for too long (" <<
@@ -154,7 +155,16 @@
   if (m_dropPolicy == DROP_OLDEST)
     {
       NS_LOG_DEBUG ("Remove the oldest item in the queue");
-      DoRemove (begin ());
+      if (pos == begin ())
+        {
+          // Avoid invalidating pos
+          DoRemove (begin ());
+          pos = begin ();
+        }
+      else
+        {
+          DoRemove (begin ());
+        }
     }
 
   return DoEnqueue (pos, item);
@@ -558,4 +568,104 @@
   return QueueBase::GetNBytes ();
 }
 
+uint32_t
+WifiMacQueue::GetNPackets (uint8_t tid, Mac48Address dest) const
+{
+  WifiAddressTidPair addressTidPair (dest, tid);
+  auto it = m_nQueuedPackets.find (addressTidPair);
+  if (it == m_nQueuedPackets.end ())
+    {
+      return 0;
+    }
+  return m_nQueuedPackets.at (addressTidPair);
+}
+
+uint32_t
+WifiMacQueue::GetNBytes (uint8_t tid, Mac48Address dest) const
+{
+  WifiAddressTidPair addressTidPair (dest, tid);
+  auto it = m_nQueuedBytes.find (addressTidPair);
+  if (it == m_nQueuedBytes.end ())
+    {
+      return 0;
+    }
+  return m_nQueuedBytes.at (addressTidPair);
+}
+
+bool
+WifiMacQueue::DoEnqueue (ConstIterator pos, Ptr<WifiMacQueueItem> item)
+{
+  Iterator ret;
+  if (Queue<WifiMacQueueItem>::DoEnqueue (pos, item, ret))
+    {
+      // update statistics about queued packets
+      if (item->GetHeader ().IsQosData ())
+        {
+          WifiAddressTidPair addressTidPair (item->GetHeader ().GetAddr1 (), item->GetHeader ().GetQosTid ());
+          auto it = m_nQueuedPackets.find (addressTidPair);
+          if (it == m_nQueuedPackets.end ())
+            {
+              m_nQueuedPackets[addressTidPair] = 0;
+              m_nQueuedBytes[addressTidPair] = 0;
+            }
+          m_nQueuedPackets[addressTidPair]++;
+          m_nQueuedBytes[addressTidPair] += item->GetSize ();
+        }
+      // set item's information about its position in the queue
+      item->m_queueIts = {{this, ret}};
+      return true;
+    }
+  return false;
+}
+
+Ptr<WifiMacQueueItem>
+WifiMacQueue::DoDequeue (ConstIterator pos)
+{
+  Ptr<WifiMacQueueItem> item = Queue<WifiMacQueueItem>::DoDequeue (pos);
+
+  if (item != 0 && item->GetHeader ().IsQosData ())
+    {
+      WifiAddressTidPair addressTidPair (item->GetHeader ().GetAddr1 (), item->GetHeader ().GetQosTid ());
+      NS_ASSERT (m_nQueuedPackets.find (addressTidPair) != m_nQueuedPackets.end ());
+      NS_ASSERT (m_nQueuedPackets[addressTidPair] >= 1);
+      NS_ASSERT (m_nQueuedBytes[addressTidPair] >= item->GetSize ());
+
+      m_nQueuedPackets[addressTidPair]--;
+      m_nQueuedBytes[addressTidPair] -= item->GetSize ();
+    }
+
+  if (item != 0)
+    {
+      NS_ASSERT (item->m_queueIts.size () == 1);
+      item->m_queueIts.clear ();
+    }
+
+  return item;
+}
+
+Ptr<WifiMacQueueItem>
+WifiMacQueue::DoRemove (ConstIterator pos)
+{
+  Ptr<WifiMacQueueItem> item = Queue<WifiMacQueueItem>::DoRemove (pos);
+
+  if (item != 0 && item->GetHeader ().IsQosData ())
+    {
+      WifiAddressTidPair addressTidPair (item->GetHeader ().GetAddr1 (), item->GetHeader ().GetQosTid ());
+      NS_ASSERT (m_nQueuedPackets.find (addressTidPair) != m_nQueuedPackets.end ());
+      NS_ASSERT (m_nQueuedPackets[addressTidPair] >= 1);
+      NS_ASSERT (m_nQueuedBytes[addressTidPair] >= item->GetSize ());
+
+      m_nQueuedPackets[addressTidPair]--;
+      m_nQueuedBytes[addressTidPair] -= item->GetSize ();
+    }
+
+  if (item != 0)
+    {
+      NS_ASSERT (item->m_queueIts.size () == 1);
+      item->m_queueIts.clear ();
+    }
+
+  return item;
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-mac-queue.h ns-3.34/src/wifi/model/wifi-mac-queue.h
--- ns-3.33/src/wifi/model/wifi-mac-queue.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-mac-queue.h	2021-07-14 10:31:07.000000000 -0700
@@ -26,6 +26,8 @@
 
 #include "wifi-mac-queue-item.h"
 #include "ns3/queue.h"
+#include <unordered_map>
+#include "qos-utils.h"
 
 namespace ns3 {
 
@@ -97,7 +99,7 @@
    * \param item the Wifi MAC queue item to be enqueued at the end
    * \return true if success, false if the packet has been dropped
    */
-  bool Enqueue (Ptr<WifiMacQueueItem> item);
+  bool Enqueue (Ptr<WifiMacQueueItem> item) override;
   /**
    * Enqueue the given Wifi MAC queue item at the <i>front</i> of the queue.
    *
@@ -118,7 +120,7 @@
    *
    * \return the packet
    */
-  Ptr<WifiMacQueueItem> Dequeue (void);
+  Ptr<WifiMacQueueItem> Dequeue (void) override;
   /**
    * Search and return, if present in the queue, the first packet (either Data
    * frame or QoS Data frame) having the receiver address equal to <i>addr</i>.
@@ -180,7 +182,7 @@
    *
    * \return the packet
    */
-  Ptr<const WifiMacQueueItem> Peek (void) const;
+  Ptr<const WifiMacQueueItem> Peek (void) const override;
   /**
    * Search and return, if present in the queue, the first packet (either Data
    * frame or QoS Data frame) having the receiver address equal to <i>addr</i>.
@@ -236,7 +238,7 @@
    *
    * \return the packet
    */
-  Ptr<WifiMacQueueItem> Remove (void);
+  Ptr<WifiMacQueueItem> Remove (void) override;
   /**
    * If exists, removes <i>packet</i> from queue and returns true. Otherwise it
    * takes no effects and return false. Deletion of the packet is
@@ -260,7 +262,7 @@
   ConstIterator Remove (ConstIterator pos, bool removeExpired = false);
   /**
    * Return the number of packets having destination address specified by
-   * <i>dest</i>.
+   * <i>dest</i>. The complexity is linear in the size of the queue.
    *
    * \param dest the given destination
    *
@@ -269,7 +271,8 @@
   uint32_t GetNPacketsByAddress (Mac48Address dest);
   /**
    * Return the number of QoS packets having TID equal to <i>tid</i> and
-   * destination address equal to <i>dest</i>.
+   * destination address equal to <i>dest</i>.  The complexity is linear in
+   * the size of the queue.
    *
    * \param tid the given TID
    * \param dest the given destination
@@ -279,6 +282,31 @@
   uint32_t GetNPacketsByTidAndAddress (uint8_t tid, Mac48Address dest);
 
   /**
+   * Return the number of QoS packets in the queue having tid equal to <i>tid</i>
+   * and destination address equal to <i>dest</i>. The complexity in the average
+   * case is constant. However, packets expired since the last non-const
+   * operation on the queue are included in the returned count.
+   *
+   * \param tid the given TID
+   * \param dest the given destination
+   *
+   * \return the number of QoS packets in the queue
+   */
+  uint32_t GetNPackets (uint8_t tid, Mac48Address dest) const;
+  /**
+   * Return the number of bytes in the queue having tid equal to <i>tid</i> and
+   * destination address equal to <i>dest</i>. The complexity in the average
+   * case is constant. However, packets expired since the last non-const
+   * operation on the queue are included in the returned count.
+   *
+   * \param tid the given TID
+   * \param dest the given destination
+   *
+   * \return the number of bytes in the queue
+   */
+  uint32_t GetNBytes (uint8_t tid, Mac48Address dest) const;
+
+  /**
    * \return true if the queue is empty; false otherwise
    *
    * Overrides the IsEmpty method provided by QueueBase
@@ -312,11 +340,44 @@
    * \return true if the item is removed, false otherwise
    */
   bool TtlExceeded (ConstIterator &it);
+  /**
+   * Wrapper for the DoEnqueue method provided by the base class that additionally
+   * sets the iterator field of the item and updates internal statistics, if
+   * insertion succeeded.
+   *
+   * \param pos the position before where the item will be inserted
+   * \param item the item to enqueue
+   * \return true if success, false if the packet has been dropped.
+   */
+  bool DoEnqueue (ConstIterator pos, Ptr<WifiMacQueueItem> item);
+  /**
+   * Wrapper for the DoDequeue method provided by the base class that additionally
+   * resets the iterator field of the item and updates internal statistics, if
+   * an item was dequeued.
+   *
+   * \param pos the position of the item to dequeue
+   * \return the item.
+   */
+  Ptr<WifiMacQueueItem> DoDequeue (ConstIterator pos);
+  /**
+   * Wrapper for the DoRemove method provided by the base class that additionally
+   * resets the iterator field of the item and updates internal statistics, if
+   * an item was dropped.
+   *
+   * \param pos the position of the item to drop
+   * \return the item.
+   */
+  Ptr<WifiMacQueueItem> DoRemove (ConstIterator pos);
 
   Time m_maxDelay;                          //!< Time to live for packets in the queue
   DropPolicy m_dropPolicy;                  //!< Drop behavior of queue
   mutable bool m_expiredPacketsPresent;     //!< True if expired packets are in the queue
 
+  /// Per (MAC address, TID) pair queued packets
+  std::unordered_map<WifiAddressTidPair, uint32_t, WifiAddressTidHash> m_nQueuedPackets;
+  /// Per (MAC address, TID) pair queued bytes
+  std::unordered_map<WifiAddressTidPair, uint32_t, WifiAddressTidHash> m_nQueuedBytes;
+
   /// Traced callback: fired when a packet is dropped due to lifetime expiration
   TracedCallback<Ptr<const WifiMacQueueItem> > m_traceExpired;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-mac-queue-item.cc ns-3.34/src/wifi/model/wifi-mac-queue-item.cc
--- ns-3.33/src/wifi/model/wifi-mac-queue-item.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-mac-queue-item.cc	2021-07-14 10:31:07.000000000 -0700
@@ -27,6 +27,7 @@
 #include "wifi-mac-queue-item.h"
 #include "wifi-mac-trailer.h"
 #include "wifi-utils.h"
+#include "msdu-aggregator.h"
 
 namespace ns3 {
 
@@ -83,9 +84,21 @@
 }
 
 uint32_t
+WifiMacQueueItem::GetPacketSize (void) const
+{
+  return m_packet->GetSize ();
+}
+
+uint32_t
 WifiMacQueueItem::GetSize (void) const
 {
-  return m_packet->GetSize () + m_header.GetSerializedSize () + WIFI_MAC_FCS_LENGTH;
+  return GetPacketSize () + m_header.GetSerializedSize () + WIFI_MAC_FCS_LENGTH;
+}
+
+bool
+WifiMacQueueItem::IsFragment (void) const
+{
+  return m_header.IsMoreFragments () || m_header.GetFragmentNumber () > 0;
 }
 
 Ptr<Packet>
@@ -110,6 +123,7 @@
       // An MSDU is going to be aggregated to this MPDU, hence this has to be an A-MSDU now
       Ptr<const WifiMacQueueItem> firstMsdu = Create<const WifiMacQueueItem> (*this);
       m_packet = Create<Packet> ();
+      m_queueIts.clear ();
       DoAggregate (firstMsdu);
 
       m_header.SetQosAmsdu ();
@@ -156,6 +170,7 @@
   hdr.SetLength (static_cast<uint16_t> (msdu->GetPacket ()->GetSize ()));
 
   m_msduList.push_back ({msdu->GetPacket (), hdr});
+  m_queueIts.insert (m_queueIts.end (), msdu->m_queueIts.begin (), msdu->m_queueIts.end ());
 
   // build the A-MSDU
   NS_ASSERT (m_packet);
@@ -186,14 +201,25 @@
   m_tstamp = Max (m_tstamp, msdu->GetTimeStamp ());
 }
 
+bool
+WifiMacQueueItem::IsQueued (void) const
+{
+  return !m_queueIts.empty ();
+}
+
+const std::list<WifiMacQueueItem::QueueIteratorPair>&
+WifiMacQueueItem::GetQueueIteratorPairs (void) const
+{
+  return m_queueIts;
+}
 
-MsduAggregator::DeaggregatedMsdusCI
+WifiMacQueueItem::DeaggregatedMsdusCI
 WifiMacQueueItem::begin (void)
 {
   return m_msduList.begin ();
 }
 
-MsduAggregator::DeaggregatedMsdusCI
+WifiMacQueueItem::DeaggregatedMsdusCI
 WifiMacQueueItem::end (void)
 {
   return m_msduList.end ();
@@ -202,9 +228,11 @@
 void
 WifiMacQueueItem::Print (std::ostream& os) const
 {
-  os << "size=" << m_packet->GetSize ()
+  os << m_header.GetTypeString ()
+     << ", payloadSize=" << GetPacketSize ()
      << ", to=" << m_header.GetAddr1 ()
      << ", seqN=" << m_header.GetSequenceNumber ()
+     << ", duration/ID=" << m_header.GetDuration ()
      << ", lifetime=" << (Simulator::Now () - m_tstamp).As (Time::US);
   if (m_header.IsQosData ())
     {
@@ -222,6 +250,7 @@
           os << ", ack=BlockAck";
         }
     }
+  os << ", packet=" << m_packet;
 }
 
 std::ostream & operator << (std::ostream &os, const WifiMacQueueItem &item)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-mac-queue-item.h ns-3.34/src/wifi/model/wifi-mac-queue-item.h
--- ns-3.33/src/wifi/model/wifi-mac-queue-item.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-mac-queue-item.h	2021-07-14 10:31:07.000000000 -0700
@@ -26,13 +26,14 @@
 
 #include "ns3/nstime.h"
 #include "wifi-mac-header.h"
-#include "msdu-aggregator.h"
 #include "amsdu-subframe-header.h"
+#include <list>
 
 namespace ns3 {
 
 class QosBlockedDestinations;
 class Packet;
+class WifiMacQueue;
 
 /**
  * \ingroup wifi
@@ -99,6 +100,21 @@
   uint32_t GetSize (void) const;
 
   /**
+   * \brief Return the size in bytes of the packet or control header or management
+   *        header stored by this item.
+   *
+   * \return the size in bytes of the packet or control header or management header
+   *         stored by this item
+   */
+  uint32_t GetPacketSize (void) const;
+
+  /**
+   * Return true if this item contains an MSDU fragment, false otherwise
+   * \return true if this item contains an MSDU fragment, false otherwise
+   */
+  bool IsFragment (void) const;
+
+  /**
    * \brief Aggregate the MSDU contained in the given MPDU to this MPDU (thus
    *        constituting an A-MSDU). Note that the given MPDU cannot contain
    *        an A-MSDU.
@@ -106,18 +122,49 @@
    */
   void Aggregate (Ptr<const WifiMacQueueItem> msdu);
 
+  /// DeaggregatedMsdus typedef
+  typedef std::list<std::pair<Ptr<const Packet>, AmsduSubframeHeader> > DeaggregatedMsdus;
+  /// DeaggregatedMsdusCI typedef
+  typedef std::list<std::pair<Ptr<const Packet>, AmsduSubframeHeader> >::const_iterator DeaggregatedMsdusCI;
+
   /**
    * \brief Get a constant iterator pointing to the first MSDU in the list of aggregated MSDUs.
    *
    * \return a constant iterator pointing to the first MSDU in the list of aggregated MSDUs
    */
-  MsduAggregator::DeaggregatedMsdusCI begin (void);
+  DeaggregatedMsdusCI begin (void);
   /**
    * \brief Get a constant iterator indicating past-the-last MSDU in the list of aggregated MSDUs.
    *
    * \return a constant iterator indicating past-the-last MSDU in the list of aggregated MSDUs
    */
-  MsduAggregator::DeaggregatedMsdusCI end (void);
+  DeaggregatedMsdusCI end (void);
+
+  /// Const iterator typedef
+  typedef std::list<Ptr<WifiMacQueueItem>>::const_iterator ConstIterator;
+  /// Information needed to remove an MSDU from the queue
+  struct QueueIteratorPair
+  {
+    WifiMacQueue* queue;  //!< pointer to the queue where the MSDU is enqueued
+    ConstIterator it;     //!< iterator pointing to the MSDU in the queue
+  };
+
+  /**
+   * Return true if this item is stored in some queue, false otherwise.
+   *
+   * \return true if this item is stored in some queue, false otherwise
+   */
+  bool IsQueued (void) const;
+
+  /**
+   * Get a const reference to the list of iterators pointing to the positions
+   * of the items in the queue. The list is empty if the item is not stored in
+   * a queue. The list contains multiple iterators in case of A-MSDU that is not
+   * stored in the Block Ack Manager retransmit queue.
+   *
+   * \return the list of iterators pointing to the positions of the items in the queue
+   */
+  const std::list<QueueIteratorPair>& GetQueueIteratorPairs (void) const;
 
   /**
    * \brief Get the MAC protocol data unit (MPDU) corresponding to this item
@@ -142,10 +189,13 @@
    */
   void DoAggregate (Ptr<const WifiMacQueueItem> msdu);
 
+  friend class WifiMacQueue;  // to set QueueIteratorPair information
+
   Ptr<const Packet> m_packet;                   //!< The packet (MSDU or A-MSDU) contained in this queue item
   WifiMacHeader m_header;                       //!< Wifi MAC header associated with the packet
   Time m_tstamp;                                //!< timestamp when the packet arrived at the queue
-  MsduAggregator::DeaggregatedMsdus m_msduList; //!< The list of aggregated MSDUs included in this MPDU
+  DeaggregatedMsdus m_msduList;                 //!< The list of aggregated MSDUs included in this MPDU
+  std::list<QueueIteratorPair> m_queueIts;      //!< Queue iterators pointing to this MSDU(s), if queued
 };
 
 /**
